unit graftrix;

{ Various graphics-writing operations.}

interface
uses dos,crt,graph,mycrt;

type ylisttype = array[0..15] of integer;

procedure cgabars(mask: word; ylist: pointer);
procedure initbar;
procedure monobars(mask: word; ylist: pointer);
procedure plotbar(y,x: integer);
procedure retrace;
 procedure pltmon(x,y,color: word);
 procedure pltcga(x,y,color: word);
 procedure pltega(x,y,color: word);
function getframerate: integer;
procedure plot(x,y,c: word);

implementation

{Assembly-language routines, in bars.obj }

{$F+}   { force far calls }

{
 Mask is a set[0..15] designating which cursors are to be shown. See below
 for how a word variable is given the same address as the set variable. Ylist
 is an array[0..15] of integer in which the values of the cursor positions are
 put. The procedure erases the old bars and writes the new ones to the screen
}
procedure initbar; external;
procedure cgabars(mask: word; ylist: pointer); external;
procedure monobars(mask: word; ylist: pointer); external;

{ nvCGA waits for NOT vertical retrace; vCGA waits for vertical retrace. }
procedure nvCGA; external;
procedure vCGA; external;

{ nvMONO waits for NOT vertical retrace; vMONO waits for vertical retrace. }
procedure nvMONO; external;
procedure vMONO; external;

{ returns game-paddle x or y for channel  0 or 1, puts result in handle.
  Use this way: rawhan(0,@handle); @ means address-of.
}
procedure rawhan(channel: word; handle: pointer); external;

{$L BARS.OBJ}    { link bars.obj. If necessary put proper path here }
{$F-}

{$f+}
 procedure pltmon(x,y,color: word); external;
 procedure pltcga(x,y,color: word); external;
 procedure pltega(x,y,color: word); external;
 procedure scrmon(x,y,w,h: word); external;
 procedure scrcga(x,y,w,h: word); external;
 procedure screga(x,y,w,h: word); external;
 {$L \tp\obj\scrlwind.obj }
{$f-}

{ -------------------------------------------------------------------------}
procedure plot(x,y,c: word);
begin
 if graphdriver in [CGA, ATT400] then pltcga(x,y,c)
 else if graphdriver in [EGA,VGA,EGAMONO,EGA64] then pltega(x,y,c)
 else pltmon(x,y,c);
end;



function getframerate: integer;
var n1,n2: word;
    u: integer;
    regs: registers;
begin
 repeat
  regs.ax := 0;
  intr($1a,regs);
  n1 := regs.dx;
  for u := 0 to 99 do retrace;
  regs.ax := 0;
  intr($1a,regs);
  n2 := regs.dx;
 until n2 > n1;
 getframerate := 10 * round(182.06481/(n2 - n1));
end;

procedure retrace;
begin
 case graphdriver of
  8,9,4: begin
           while (port[$3da] and 8) = 8 do ;
           while (port[$3da] and 8) = 0 do ;
          end;
  7,5: begin
           while (port[$3ba] and $80) = 0 do ;
           while (port[$3ba] and $80) = $80 do ;
           end;
  ELSE begin
          while (port[$3da] and 8) = 0 do ;
          while (port[$3da] and 8) = 8 do ;
       end;
 end;
end;

procedure plotbcga(y,x: word);
const oldy: array[0..15] of word =
            (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var j: word;
    u: ^longint;
begin
 u :=  ptr($B800,$2000 * (oldy[x] and 1) + (oldy[x] and $FFFE) * 40 + 5*x);
 u^ := longint ( 0);
 u :=  ptr($b800,$2000 * (y and 1) + (y and $FFFE) * 40 + 5*x);
 u^ := longint ($ffffff);
 oldy[x] := y;
end;

procedure plotbega(y,x: word);
const oldy: array[0..15] of word =
            (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var j: word;
    u: ^longint;
begin
 port[$3ce] := 8;
 port[$3cf] := $ff;
 u :=  ptr($A000,oldy[x] * 80 + 5*x);
 u^ := u^ and longint (0);
 u :=  ptr($A000,y * 80 + 5*x);
 u^ := u^ or $ffffff;
 oldy[x] := y;
end;

procedure plotbmono(y,x: integer);
const oldy: array[0..15] of word =
            (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
var j: word;
    u: ^longint;
begin
 if y < 0 then y := 0; if y >= vsize then y := vsize - 1;
 u :=  ptr($B000,$2000 * (oldy[x] and 3) + (oldy[x] shr 2) * 90 + 5*x + 5);
 u^ := longint (0);
 u :=  ptr($b000,$2000 * (y and 3) + (y shr 2) * 90 + 5*x + 5);
 u^ := longint ($ffffff);
 oldy[x] := y;
end;

procedure plotbar(y,x: integer);
begin
 case graphdriver of
  CGA,ATT400: plotbcga(y,x);
  EGA,VGA,EGA64,EGAMONO: plotbega(y,x);
  HercMono: plotbmono(y,x);
 end;
end;

end.