unit prtscrn;
interface
 uses dos,printer,graph,grutils;

 procedure prtscr;

implementation

const bitpat: array[0..7] of byte =
               ($80,$40,$20,$10,8,4,2,1);
      esc = #$1b;
var hsize,vsize: integer;

procedure prtmono;
var outline: array[0..719] of byte;
    x,y,col,i,j,k,y1,address: integer;
    screenbyte,inmask,outmask: byte;
    prtline: boolean;
    ch: char;
begin
 writeln(lst);
 {$i-}
 writeln(lst,esc,'A',chr(8));      { 8 dots per line feed }
 {$i+}
 if IoResult <> 0 then exit;
 fillchar(outline,720,0);
 for y := 0 to 352 do
 begin
  outmask := bitpat[y and 7];
  y1 := 90 * (y div 4);
  for x := 0 to 89 do
  begin
   address := y1 + x + $2000 * (y mod 4);
   screenbyte := mem[$b000:address];
   for i := 0 to 7 do
   begin
    k := (x shl 3) + i;
    if (screenbyte and bitpat[i]) <> 0 then
     outline[k] := (outline[k] or outmask)
   end;
  end;
  for j := 0 to 719 do if outline[j] = $1a then outline[j] := $1b;
  prtline := false;
  for j := 0 to 719 do if outline[j] <> 0 then prtline := true;
  if (y and 7) = 7 then
  begin
   if prtline then
   begin
    write(lst,esc,'*',chr(7),chr(720 mod 256),chr(720 div 256));
    for j := 0 to 719 do write(lst,chr(outline[j]));
   end;
   writeln(lst,esc,'A',chr(8));
   fillchar(outline,719,0);
  end;
 end;
 writeln(lst);
 writeln(lst,esc,'2');
end;

procedure prtcga;
var outline: array[0..639] of byte;
    x,y,col,i,j,k,y1,address: integer;
    screenbyte,inmask,outmask: byte;
    prtline: boolean;
    ch: char;
begin
 {$i-}
 writeln(lst,esc,'A',chr(8));      { 8 dots per line feed }
 {$i+}
 if IoResult <> 0 then exit;
 fillchar(outline,640,0);
 for y := 0 to 199 do
 begin
  outmask := bitpat[y and 7];
  y1 := 80 * (y div 2);
  for x := 0 to 79 do
  begin
   address := y1 + x + $2000 * (y mod 2);
   screenbyte := mem[$b800:address];
   for i := 0 to 7 do
   begin
    k := (x shl 3) + i;
    if (screenbyte and bitpat[i]) <> 0 then
     outline[k] := (outline[k] or outmask)
   end;
  end;
  for j := 0 to 639 do if outline[j] = $1a then outline[j] := $1b;
  prtline := false;
  for j := 0 to 639 do if outline[j] <> 0 then prtline := true;
  if (y and 7) = 7 then
  begin
   if prtline then
   begin
    write(lst,esc,'*',chr(7),chr(640 mod 256),chr(640 div 256));
    for j := 0 to 639 do write(lst,chr(outline[j]));
   end;
   writeln(lst,esc,'A',chr(8));
   fillchar(outline,640,0);
  end;
 end;
 writeln(lst);
 writeln(lst,esc,'2');
end;

procedure prtega;
var outline: array[0..800] of byte;
    x,y,col,i,j,k,y1,address: longint;
    screenbyte,inmask,outmask,map: byte;
    prtline: boolean;
    ch: char;
begin
 port[$3ce] := 8;
 port[$3cf] := $ff;
 {$i-}
 writeln(lst,esc,'A',chr(8));      { 8 dots per line feed }
 {$i+}
 if IoResult <> 0 then exit;
 fillchar(outline,hsize,0);
 for y := 0 to vsize + 4 do
 begin
  outmask := bitpat[y and 7];
  for x := 0 to 79 do
  begin
   address := 80 * y + x;
   screenbyte := 0;
   for map := 0 to 3 do    { "or" together all 4 bit planes }
   begin
    port[$3ce] := 4;
    port[$3cf] := map;
    screenbyte := screenbyte or mem[$A000:address];
   end;
   for i := 0 to 7 do
   begin
    k := (x shl 3) + i;
    if (screenbyte and bitpat[i]) <> 0 then
     outline[k] := (outline[k] or outmask)
   end;
  end;
  for j := 0 to hsize - 1 do if outline[j] = $1a then outline[j] := $1b;
  prtline := false;
  for j := 0 to hsize - 1 do if outline[j] <> 0 then prtline := true;
  if (y and 7) = 7 then
  begin
   if prtline then
   begin
    write(lst,esc,'*',chr(6),chr(hsize mod 256),chr(hsize div 256));
    for j := 0 to hsize - 1 do write(lst,chr(outline[j]));
   end;
   writeln(lst,esc,'A',chr(8));
   fillchar(outline,hsize,0);
  end;
 end;
 writeln(lst);
 writeln(lst,esc,'2');
end;

procedure prtscr;
begin
  hsize := getmaxx + 1;
  vsize := getmaxy + 1;
     case graphdriver of
      CGA,ATT400: prtcga;
      VGA: prtega;
      HercMono: prtmono;
      else prtega;
     end;
end;

end.
